/*
 *	Ohio Trollius
 *
 * Copyright (c) 2001-2002 The Trustees of Indiana University.  
 *                         All rights reserved.
 * Copyright (c) 1998-2001 University of Notre Dame. 
 *                         All rights reserved.
 * Copyright (c) 1994-1998 The Ohio State University.  
 *                         All rights reserved.
 * 
 * This file is part of the XMTV software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * XMTV source distribution.
 *
 *	$Id: lamtv_f.c,v 1.2 2002/12/09 20:25:14 brbarret Exp $
 *
 *	Function:	- F77 wrappers for libmtv.a
 */

#include <lam_config.h>
#include <terror.h>
#include <tvreq.h>

#if FORTRANNOUNDERSCORE

#define lamf_tvclr_	lamf_tvclr
#define lamf_tvrect_	lamf_tvrect
#define lamf_tvsnake_	lamf_tvsnake
#define lamf_tvtext_	lamf_tvtext
#define lamf_tvstate_	lamf_tvstate
#define lamf_rtvclr_	lamf_rtvclr
#define lamf_rtvrect_	lamf_rtvrect
#define lamf_rtvsnake_	lamf_rtvsnake
#define lamf_rtvtext_	lamf_rtvtext
#define lamf_rtvstate_	lamf_rtvstate

#elif FORTRANDOUBLEUNDERSCORE

#define lamf_tvclr_	lamf_tvclr__
#define lamf_tvrect_	lamf_tvrect__
#define lamf_tvsnake_	lamf_tvsnake__
#define lamf_tvtext_	lamf_tvtext__
#define lamf_tvstate_	lamf_tvstate__
#define lamf_rtvclr_	lamf_rtvclr__
#define lamf_rtvrect_	lamf_rtvrect__
#define lamf_rtvsnake_	lamf_rtvsnake__
#define lamf_rtvtext_	lamf_rtvtext__
#define lamf_rtvstate_	lamf_rtvstate__

#endif

/*
 * external functions
 */
extern char		*f2cstring();

/*
 * nodeless interface
 */
void lamf_tvclr_(ierr) int *ierr; { *ierr = lam_tvclr(); }

void lamf_tvrect_(x, y, xl, yl, c, ierr)
	int *x, *y, *xl, *yl, *ierr; char *c;
	{ *ierr = lam_tvrect(*x, *y, *xl, *yl, c); }

void lamf_tvsnake_(x, xl, c, ierr) int *x, *xl, *ierr; char *c;
	{ *ierr = lam_tvsnake(*x, *xl, c); }

void lamf_tvtext_(x, y, c, txt, ierr, len)
	int *x, *y, *c, *ierr; char *txt; unsigned int len;
	{ char *str; str = f2cstring(txt, len);
	if (str == 0) { *ierr = errno; return; }
	*ierr = lam_tvtext(*x, *y, *c, str); free(str); }

void lamf_tvstate_(xl, yl, nc, xt, yt, ierr)
	int *xl, *yl, *nc, *xt, *yt, *ierr;
	{ struct tvstate i; *ierr = lam_tvstate(&i);
	if (*ierr == 0) { *xl = i.tvs_xlen; *yl = i.tvs_ylen;
		*nc = i.tvs_ncolour; *xt = i.tvs_xtext; *yt = i.tvs_ytext; } }

/*
 * node level interface
 */
void lamf_rtvclr_(n, ierr) int *n, *ierr; { *ierr = lam_rtvclr(*n); }

void lamf_rtvrect_(n, x, y, xl, yl, c, ierr)
	int *n, *x, *y, *xl, *yl, *ierr; char *c;
	{ *ierr = lam_rtvrect(*n, *x, *y, *xl, *yl, c); }

void lamf_rtvsnake_(n, x, xl, c, ierr) int *n, *x, *xl, *ierr; char *c;
	{ *ierr = lam_rtvsnake(*n, *x, *xl, c); }

void lamf_rtvtext_(n, x, y, c, txt, ierr, len)
	int *n, *x, *y, *c, *ierr; char *txt; unsigned int len;
	{ char *str; str = f2cstring(txt, len);
	if (str == 0) { *ierr = errno; return; }
	*ierr = lam_rtvtext(*n, *x, *y, *c, str); free(str); }

void lamf_rtvstate_(n, xl, yl, nc, xt, yt, ierr)
	int *n, *xl, *yl, *nc, *xt, *yt, *ierr;
	{ struct tvstate i; *ierr = lam_rtvstate(*n, &i);
	if (*ierr == 0) { *xl = i.tvs_xlen; *yl = i.tvs_ylen;
		*nc = i.tvs_ncolour; *xt = i.tvs_xtext; *yt = i.tvs_ytext; } }
