/*
 *	Ohio Trollius
 *
 * Copyright (c) 2001-2002 The Trustees of Indiana University.  
 *                         All rights reserved.
 * Copyright (c) 1998-2001 University of Notre Dame. 
 *                         All rights reserved.
 * Copyright (c) 1994-1998 The Ohio State University.  
 *                         All rights reserved.
 * 
 * This file is part of the XMTV software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * XMTV source distribution.
 *
 *	$Id: rtvtext.c,v 1.3 2002/12/09 20:25:14 brbarret Exp $
 * 
 *	Function:	- plot a text string on the graphic screen
 *			- limitation: strlen(text) < MAXNMSGLEN
 *	Accepts: 	- destination node
 *			- x text-ordinate of first character
 *			- y text-ordinate of first character
 *			- text colour
 *			- text string
 *	Returns:	- 0 or ERROR
 */

#include <string.h>

#include <events.h>
#include <net.h>
#include <portable.h>
#include <tvreq.h>

int
lam_rtvtext(node, x1, y1, colour, text)

int4			node;
int4			x1;
int4			y1;
int4			colour;
char			*text;

{
	struct nmsg	nhead;		/* message header */
	struct tvreq	*request;	/* ptr to mtvd request */
/*
 * Set up the request message.
 */
 	request = (struct tvreq *) nhead.nh_data;
	request->tvq_req = TVQTEXT;
	request->tvq_x1	 = x1;
	request->tvq_y1	 = y1;
	request->tvq_colour = colour;

	nhead.nh_node = node;
	nhead.nh_event = EVMTVD;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = strlen(text) + 1;
	nhead.nh_msg = text;

	return(nsend(&nhead));
}
