/*
 *	Ohio Trollius
 *
 * Copyright (c) 2001-2002 The Trustees of Indiana University.  
 *                         All rights reserved.
 * Copyright (c) 1998-2001 University of Notre Dame. 
 *                         All rights reserved.
 * Copyright (c) 1994-1998 The Ohio State University.  
 *                         All rights reserved.
 * 
 * This file is part of the XMTV software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * XMTV source distribution.
 *
 *	$Id: tvreq.h,v 1.2 2002/12/09 20:25:14 brbarret Exp $
 * 
 *	Function:	- graphics templates and constants
 */

#ifndef _TVREQ
#define _TVREQ

#include <portable.h>

/*
 * constants
 */
#define TVQMAX		5			/* # of requests */

#define TVQCLR		((int4) 0)		/* clear screen */
#define TVQRECT		((int4) 1)		/* plot rect. region */
#define TVQSNAKE	((int4) 2)		/* plot snake region */
#define TVQTEXT		((int4) 3)		/* write text string */
#define TVQSTATE	((int4) 4)		/* get state info. */

/*
 * structures
 */
struct tvreq {					/* graphics request */
	int4		tvq_req;		/* request code */
	int4		tvq_src_node;		/* client nodeid */
	int4		tvq_src_event;		/* client event */
	int4		tvq_param3;
#define tvq_x1		tvq_param3		/* point x ordinate */
	int4		tvq_param4;
#define tvq_y1		tvq_param4		/* point y ordinate */
	int4		tvq_param5;
#define tvq_xlen	tvq_param5		/* rectangle width */
#define tvq_len		tvq_param5		/* snake length */
#define tvq_colour	tvq_param5		/* text colour */
	int4		tvq_param6;
#define tvq_ylen	tvq_param6		/* rectangle height */
};

struct tvreply {				/* graphics reply */
	int4		tvr_ret;		/* return value */
	int4		tvr_errno;		/* error code */
	int4		tvr_param2;
#define	tvr_xlen	tvr_param2		/* screen pixel width */
	int4		tvr_param3;
#define tvr_ylen	tvr_param3		/* screen pixel height */
	int4		tvr_param4;
#define tvr_ncolour	tvr_param4		/* number of colours */
	int4		tvr_param5;
#define tvr_xtext	tvr_param5		/* screen character width */
	int4		tvr_param6;
#define tvr_ytext	tvr_param6		/* screen character height */
};

struct tvstate {				/* graphics state info. */
	int4		tvs_xlen;		/* screen pixel width */
	int4		tvs_ylen;		/* screen pixel height */
	int4		tvs_ncolour;		/* number of colours */
	int4		tvs_xtext;		/* screen character width */
	int4		tvs_ytext;		/* screen character height */
};

/*
 * prototypes
 */
#ifndef __ARGS
#if defined(__STDC__) || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int		lam_tvclr __ARGS((void));
extern int		lam_tvrect __ARGS((int4 x, int4 y,
					int4 xlen, int4 ylen, char *col));
extern int		lam_tvsnake __ARGS((int4 x, int4 len, char *col ));
extern int		lam_tvstate __ARGS((struct tvstate *pstate));
extern int		lam_tvtext __ARGS((int4 x, int4 y, int4 c, char *txt));

#ifdef __cplusplus
}
#endif

#endif /* _TVREQ */
